stages:
  - build
  - test
  - deploy

.ssh_keyrule:
  before_script:
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo ${SSH_KEY} | base64 -d > ~/.ssh/id_ed25519
    - chmod 600 ~/.ssh/id_ed25519
    - ssh-keyscan -t rsa gitlab.com >> ~/.ssh/known_hosts
    - export ANSIBLE_HOST_KEY_CHECKING=False
  after_script:
    - rm ~/.ssh/id_ed25519

build:
  stage: build
  script:
    - echo "build"
  tags:
    - my_runner

deploy_to_test:
  stage: test
  variables:
    APPENV: "TEST"
  extends:
    - .ssh_keyrule
  script:
    - ansible-playbook --key-file ./secret/id_ed25519 --user ubuntu -i infra/ansible_infra/hosts infra/ansible_infra/all.yml -D -t "${APPENV}"
    - ansible-playbook --private-key ./secret/id_ed25519 --user ubuntu -i service/hosts service/service.yml -D -t "${APPENV}"
  tags:
    - my_runner

deploy_mon_agent_to_test:
  stage: test
  variables:
    APPENV: "TEST"
  extends:
    - .ssh_keyrule
  script:
    - ansible-playbook --key-file ./secret/id_ed25519 --user ubuntu -i infra/ansible_infra/hosts infra/ansible_infra/monitor_node.yml -D -t "${APPENV}"
  tags:
    - my_runner
  rules:
    - when: manual


deploy_to_prod:
  stage: deploy
  variables:
    FOLDER_NAME: ${CI_COMMIT_SHA}
    APPENV: "PROD"
  extends:
    - .ssh_keyrule
  script:
    - ansible-playbook --key-file ./secret/id_ed25519 --user ubuntu -i infra/ansible_infra/hosts infra/ansible_infra/all.yml -D -t "${APPENV}"
    - ansible-playbook --private-key ./secret/id_ed25519 --user ubuntu -i service/hosts service/service.yml -D -t "${APPENV}"
  tags:
    - my_runner
  rules:
    - when: manual
  needs: []

deploy_mon_agent_to_prod:
  stage: deploy
  variables:
    FOLDER_NAME: ${CI_COMMIT_SHA}
    APPENV: "PROD"
  extends:
    - .ssh_keyrule
  script:
    - ansible-playbook --key-file ./secret/id_ed25519 --user ubuntu -i infra/ansible_infra/hosts infra/ansible_infra/monitor_node.yml -D -t "${APPENV}"
  tags:
    - my_runner
  rules:
    - when: manual
  needs: []

deploy_monitor_servers:
  stage: deploy
  extends:
    - .ssh_keyrule
  script:
    - ansible-playbook --key-file ./secret/id_ed25519 --user ubuntu -i infra/ansible_infra/hosts infra/ansible_infra/monitorservers.yml -D
  tags:
    - my_runner
  rules:
    - when: manual
  needs: []